ArgumentException Sınıf

Tanım

Bir yönteme verilen bağımsız değişkenlerden biri geçerli olmadığında oluşturulan özel durum.The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : Exception
public ref class ArgumentException : SystemException
public class ArgumentException : Exception
public class ArgumentException : SystemException
[System.Serializable]
public class ArgumentException : SystemException
[System.Serializable]
[System.Runtime.InteropServices.ComVisible(true)]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit Exception
type ArgumentException = class
    inherit SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
[<System.Serializable>]
type ArgumentException = class
    inherit SystemException
    interface ISerializable
[<System.Serializable>]
[<System.Runtime.InteropServices.ComVisible(true)>]
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits Exception
Public Class ArgumentException
Inherits SystemException
Devralma
ArgumentException
Devralma
ArgumentException
Türetilmiş
Öznitelikler
Uygulamalar

Örnekler

Aşağıdaki örnek, nasıl throw ve yakalayabileceğinizi gösterir ArgumentException .The following example demonstrates how to throw and catch an ArgumentException. ArgumentException. GetType () kullanır. Özel durum nesnesinin adını göstermek için Name özelliği ve ayrıca, Message özel durum iletisinin metnini göstermek için özelliğini kullanır.It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example
{
    static void Main()
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num)
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num),
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

Açıklamalar

ArgumentException bir yöntem çağrıldığında ve geçilen bağımsız değişkenlerden en az biri çağrılan metodun parametre belirtimini karşılamadığında oluşturulur.ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. ParamNameÖzelliği geçersiz bağımsız değişkeni tanımlar.The ParamName property identifies the invalid argument.

En yaygın olarak, ArgumentException ortak dil çalışma zamanı veya başka bir sınıf kitaplığı tarafından oluşturulur ve geliştirici hatasını gösterir.Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. Kodunuzda bir oluşturma yaparsanız ArgumentException , özel durumun Message özelliğinin geçersiz bağımsız değişkeni ve beklenen değer aralığını tanımlayan anlamlı bir hata iletisi içerdiğinden emin olmanız gerekir.If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

' Nin birincil türetilmiş sınıfları ArgumentException ArgumentNullException ve ' dir ArgumentOutOfRangeException .The primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. ArgumentExceptionTüretilmiş sınıfların hiçbirinin kabul edilebilir olduğu durumlar dışında, bu türetilmiş sınıflar yerine kullanılmalıdır.These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. Örneğin, özel durumlar şu şekilde oluşturulmalıdır:For example, exceptions should be thrown by:

  • ArgumentNullException Her ne zaman null geçerli bir bağımsız değişken olarak kabul etmayan bir yönteme geçirilir.ArgumentNullException whenever null is passed to a method that does not accept it as a valid argument.

  • ArgumentOutOfRangeException bir bağımsız değişkenin değeri kabul edilebilir değerler aralığının dışında. Örneğin, "46" değeri, oluşturma sırasında month bağımsız değişkeni olarak geçirilir DateTime .ArgumentOutOfRangeException when the value of an argument is outside the range of acceptable values; for example, when the value "46" is passed as the month argument during the creation of a DateTime.

Yöntem çağrısında herhangi bir bağımsız değişken yoksa veya hata bağımsız değişkenleri içermiyorsa, bu durumda InvalidOperationException kullanılmalıdır.If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentException 0x80070057 değerine sahip olan HRESULT COR_E_ARGUMENT kullanır.ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

Bir örneğinin ilk özellik değerlerinin listesi için ArgumentException , ArgumentException oluşturuculara bakın.For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

Oluşturucular

ArgumentException()

ArgumentException sınıfının yeni bir örneğini başlatır.Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext)

ArgumentException sınıfının yeni bir örneğini serileştirilmiş verilerle başlatır.Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String)

Belirtilen bir hata iletisiyle sınıfın yeni bir örneğini başlatır ArgumentException .Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception)

ArgumentExceptionBelirtilen bir hata iletisiyle sınıfın yeni bir örneğini ve bu özel durumun nedeni olan iç özel duruma bir başvuruyu başlatır.Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String)

ArgumentExceptionBelirtilen bir hata iletisi ve bu özel duruma neden olan parametrenin adı ile sınıfın yeni bir örneğini başlatır.Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception)

ArgumentExceptionBelirtilen bir hata iletisiyle sınıfın yeni bir örneğini, parametre adını ve bu özel durumun nedeni olan iç özel duruma bir başvuruyu başlatır.Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

Özellikler

Data

Özel durum hakkında ek kullanıcı tanımlı bilgiler sağlayan anahtar/değer çiftleri koleksiyonunu alır.Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(Devralındığı yer: Exception)
HelpLink

Bu özel durumla ilişkili Yardım dosyasının bağlantısını alır veya ayarlar.Gets or sets a link to the help file associated with this exception.

(Devralındığı yer: Exception)
HResult

Belirli bir özel duruma atanan kodlanmış bir sayısal değer olan HRESULT 'yi alır veya ayarlar.Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(Devralındığı yer: Exception)
InnerException

ExceptionGeçerli özel duruma neden olan örneği alır.Gets the Exception instance that caused the current exception.

(Devralındığı yer: Exception)
Message

Hata iletisini ve parametre adını ya da parametre adı ayarlanmamışsa yalnızca hata iletisini alır.Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName

Bu özel duruma neden olan parametrenin adını alır.Gets the name of the parameter that causes this exception.

Source

Uygulamanın veya hataya neden olan nesnenin adını alır veya ayarlar.Gets or sets the name of the application or the object that causes the error.

(Devralındığı yer: Exception)
StackTrace

Çağrı yığınında anlık çerçevelerin dize gösterimini alır.Gets a string representation of the immediate frames on the call stack.

(Devralındığı yer: Exception)
TargetSite

Geçerli özel durumu oluşturan yöntemi alır.Gets the method that throws the current exception.

(Devralındığı yer: Exception)

Yöntemler

Equals(Object)

Belirtilen nesnenin geçerli nesneye eşit olup olmadığını belirler.Determines whether the specified object is equal to the current object.

(Devralındığı yer: Object)
GetBaseException()

Türetilmiş bir sınıfta geçersiz kılınırsa, Exception bir veya daha fazla sonraki özel durumun kök nedeni olan öğesini döndürür.When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(Devralındığı yer: Exception)
GetHashCode()

Varsayılan karma işlevi olarak işlev görür.Serves as the default hash function.

(Devralındığı yer: Object)
GetObjectData(SerializationInfo, StreamingContext)

SerializationInfoNesneyi parametre adı ve ek özel durum bilgileri ile ayarlar.Sets the SerializationInfo object with the parameter name and additional exception information.

GetObjectData(SerializationInfo, StreamingContext)

Türetilmiş bir sınıfta geçersiz kılınırsa, SerializationInfo özel durum hakkındaki bilgileri ayarlar.When overridden in a derived class, sets the SerializationInfo with information about the exception.

(Devralındığı yer: Exception)
GetType()

Geçerli örneğin çalışma zamanı türünü alır.Gets the runtime type of the current instance.

(Devralındığı yer: Exception)
MemberwiseClone()

Geçerli bir basit kopyasını oluşturur Object .Creates a shallow copy of the current Object.

(Devralındığı yer: Object)
ToString()

Geçerli özel durumun dize gösterimini oluşturur ve döndürür.Creates and returns a string representation of the current exception.

(Devralındığı yer: Exception)

Ekinlikler

SerializeObjectState

Özel durum hakkında serileştirilmiş veri içeren bir özel durum nesnesi oluşturmak için bir özel durum serileştirildiğinde gerçekleşir.Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(Devralındığı yer: Exception)

Şunlara uygulanır

Ayrıca bkz.